# The Tree Project 

# ABOUT
A series of programs that builds on the tree structure, an abstract data
type used for presenting, storing and searching information

# VALUE IN MEDIA ARCHAEOLOGY 
# VALUE IN CRITICAL STUDIES
# FORMAT
Textual outputs are stored as txt files, and image outputs are stored as image files. The program process is stored in Jupyter Notebooks. 
# WHERE IS THIS FORKED FROM 
# FORK YOUR OWN 


## A Letter Tree With Hanging Fruits

### What
"A Letter Tree With Hanging Fruits" is a symbolic tree that grows 26 different fruits, with each name starting with a letter from the English alphabet. The computer program uses the tree structure, an abstract data structure used to store, retrieve and represent hierarchical information. The information, in this case, a list containing the words of the fruits, is processed hierarchically by recursion, an algorithmic procedure that constantly calls upon itself until an exit condition is met.       

### How
There are two recursive procedures applied in the program, one to build the tree, and the other to print the tree. Between line 45 and 67, the insertLeaf function recursively traverse the tree, looking for a suitable place to insert the word of the fruit as predefined by a hierarchical rule. The hierarchical rule used in the program simply compares the order of the word's first letter. Words starting with "bigger" letters will be placed on the right side, and vice versa. Between line 15 and 35, the print2DUtil_flat function visually renders the tree's levelled hierarchies. The function starts in the tree's furthest right. For words placed in "lower" levels, more empty spaces are printed, and vice versa. 

### Why
The program is intended to be a simple yet playful reflection on the convergence of mathematics, language, and symbol. While the program's association with these subjects may immediately sound daunting, as the audience pays inquisitive attention to how the program's outputs are being rendered interactively in the console, they are witnessing a tangible interplay of the subjects. 

Originally, the program was written as a response to a piece of archival information found on the subject of Chinese text processing. Due to the incompatibilities resulted from organizational differences between Chinese as an ideographic writing system and alphanumeric writing systems, such as English, advanced Chinese text processing technologies were near scarce in the early history of computing. Computationally, it was expensive and hence incompatible to accommodate a corpus of Chinese glyphs in the systems of hardware and software first intended to process alphanumeric writing systems. Here, the concept of incompatibility derives from singularly determined frameworks that are efficient and monolingual. Outside the singularly determined frameworks, there is a rich ecology of artifacts, approaches, and interpretations on Chinese text processing that each embody uniqueness and idiosyncrasy.   

Take the archival information as an example. In the early 1990s, the Chinese writer and programmer Wang Xiaobo was crafting a Chinese text editor. Wang used a binary tree structure to implement a feature to store customized word combinations.  

Hierarchy 
Dynamic programming 
Self generation of recursion 
Self modification 
permutation 
Recursion in computational linguistics
dabai dabaicai dabaiyutianxia
  

The attention to science and mathematics permeates his writing.   

hierarchical rule 
camel case and snake case 
Tree of life in (esoteric) mystery spiritualism trees

typographical qualities 
empty spaces 
vacancies

### Presentation

PyCon 

### Ring 
["I Like Mathematics And Tight Pants"](https://i.liketightpants.net/and/archives)
["Learning To Love Math"](https://sfpc.study/sessions/summer-22/learning-to-love-math)
[Seedlings](https://chenqianxun.com/projects/seedlings/)
[Metamagical Themas](https://archive.org/details/metamagicalthema0000hofs/page/9/mode/2up)


<!-- will a handwritten dynamic gif like taeyoon choi's be helpful for the thing?-- >
